import requests
import wx
import wx.svg
from ActiveBitmap import ActiveBitmap

"""

An internet connection is required for this demonstration
 what is downloaded is just an svg image of the number 4
The package requests will also need to be installed on your machine
pip install requests

"""

def iconify(icon):
    url = "https://api.iconify.design/{}.svg".format(icon.replace(':', '/'))
    content = requests.get(url).content
    return wx.svg.SVGimage.CreateFromBytes(content)

class Panel(wx.Panel):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        # preconvert svg's to bitmaps for animation sequence

        img = wx.svg.SVGimage.CreateFromFile('battery0.svg')
        bmp1 = img.ConvertToScaledBitmap(wx.Size(48,48))
        img = wx.svg.SVGimage.CreateFromFile('battery50.svg')
        bmp2 = img.ConvertToScaledBitmap(wx.Size(48,48))
        img = wx.svg.SVGimage.CreateFromFile('battery75.svg')
        bmp3 = img.ConvertToScaledBitmap(wx.Size(48,48))
        img = wx.svg.SVGimage.CreateFromFile('battery100.svg')
        bmp4 = img.ConvertToScaledBitmap(wx.Size(48,48))


        bitmap1 = ActiveBitmap(self, -1, bitmap=wx.NullBitmap, bitmap_list=[bmp1, bmp2, bmp3, bmp4,])

        ## https://icon-sets.iconify.design/fa6-solid/4/
        img = iconify("fa6-solid:4")
        bmp = img.ConvertToScaledBitmap((128, 256))  # convert to wx.Bitmap
        bitmap2 = ActiveBitmap(self, -1, bitmap=bmp)

        sizer = wx.BoxSizer(wx.VERTICAL)

        sizer.Add(bitmap1, 0, wx.EXPAND|wx.ALL, 10)
        sizer.Add(bitmap2, 0, wx.EXPAND|wx.ALL, 10)
        self.SetSizer(sizer)
        self.Layout()
        bitmap1.SetTimerPeriod(250)
        bitmap1.Activate()

if __name__ == "__main__":
    app = wx.App()
    frm = wx.Frame(None, size=(400, 500))
    panel = Panel(frm)
    frm.Show()
    app.MainLoop()
